## dune-common 2.7.0

=== dune/common/parallel/test/CMakeLists.txt ===
dune_add_test(SOURCES indexsettest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES remoteindicestest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 1 2 4
              TIMEOUT 300
              CMAKE_GUARD MPI_FOUND
              LABELS quick)

dune_add_test(SOURCES selectiontest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES syncertest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 1 2 4
              TIMEOUT 300
              CMAKE_GUARD MPI_FOUND
              LABELS quick)

dune_add_test(SOURCES variablesizecommunicatortest.cc
              MPI_RANKS 1 2 4
              TIMEOUT 300
              CMAKE_GUARD MPI_FOUND
              LABELS quick)

dune_add_test(SOURCES mpidatatest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 2
              TIMEOUT 300
              LABELS quick)

dune_add_test(SOURCES mpifuturetest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 1 2 4
              TIMEOUT 300
              LABELS quick)

dune_add_test(SOURCES mpipacktest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 2
              TIMEOUT 300
              CMAKE_GUARD MPI_FOUND
              LABELS quick)

=== dune/common/simd/test/CMakeLists.txt ===
include(DuneCMakeCompat)

# We need to explicitly instantiate the tests for small groups of types --
# else the compiler will eat excessive amounts of memory.  This way it seems
# to stay below 1GByte (with g++ 4.9.2 -O0 -g on x86_64 GNU/Linux, looking at
# standardtest).
include(DuneInstance)

set(TYPES
  char "unsigned char" "signed char"
  short int long "long long"
  "unsigned short" unsigned "unsigned long" "unsigned long long"
  wchar_t char16_t char32_t
  bool
  float double "long double"
  std::complex<float> std::complex<double> "std::complex<long double>"
  )

# Generate files with instanciations, external declarations, and also the
# invocations in the test for each instance.
dune_instance_begin(FILES looptest.hh looptest.cc)
foreach(SCALAR IN LISTS TYPES)
  dune_instance_add(ID "${SCALAR}")
  foreach(POINT IN ITEMS
      Type
      BinaryOpsScalarVector BinaryOpsVectorScalar)
    dune_instance_add(TEMPLATE POINT ID "${POINT}_${SCALAR}"
      FILES looptest_vector.cc)
  endforeach()
endforeach()
dune_instance_end()

dune_list_filter(DUNE_INSTANCE_GENERATED INCLUDE REGEX [[\.cc$]])
dune_add_test(NAME looptest
  SOURCES ${DUNE_INSTANCE_GENERATED}
  LINK_LIBRARIES dunecommon
)
# no need to install looptest.hh, used by looptest*.cc only



set(TYPES
  char "unsigned char" "signed char"
  short int long "long long"
  "unsigned short" unsigned "unsigned long" "unsigned long long"
  wchar_t char16_t char32_t
  bool
  float double "long double"
  std::complex<float> std::complex<double> "std::complex<long double>")

# Generate files with instanciations, external declarations, and also the
# invocations in the test for each instance.
dune_instance_begin(FILES standardtest.hh standardtest.cc)
foreach(SCALAR IN LISTS TYPES)
  dune_instance_add(ID "${SCALAR}" FILES standardtest_vector.cc)
endforeach()
dune_instance_end()

dune_list_filter(DUNE_INSTANCE_GENERATED INCLUDE REGEX [[\.cc$]])
dune_add_test(NAME standardtest
  SOURCES ${DUNE_INSTANCE_GENERATED}
  LINK_LIBRARIES dunecommon
)
# no need to install standardtest.hh, used by standardtest*.cc only


# as of Vc-1.3.2: Vc/common/simdarray.h:561: SimdArray<T, N> may only be used
# with T = { double, float, int32_t, uint32_t, int16_t, uint16_t }
set(VCTEST_TYPES std::int16_t std::uint16_t std::int32_t std::uint32_t float double)

# Generate files with instanciations, external declarations, and also the
# invocations in the test for each instance.
dune_instance_begin(FILES vcarraytest.hh vcarraytest.cc)
foreach(SCALAR IN LISTS VCTEST_TYPES)
  dune_instance_add(ID "${SCALAR}")
  foreach(POINT IN ITEMS
      Type
      BinaryOpsScalarVector BinaryOpsVectorScalar
      BinaryOpsProxyVector BinaryOpsVectorProxy)
    dune_instance_add(TEMPLATE POINT ID "${POINT}_${SCALAR}"
      FILES vctest_simdarray.cc vctest_simdmaskarray.cc)
  endforeach()
endforeach()
dune_instance_end()
dune_list_filter(DUNE_INSTANCE_GENERATED INCLUDE REGEX [[\.cc$]])
dune_add_test(NAME vcarraytest
  SOURCES ${DUNE_INSTANCE_GENERATED}
  LINK_LIBRARIES dunecommon
  CMAKE_GUARD Vc_FOUND
)
add_dune_vc_flags(vcarraytest)
# no need to install vcarraytest.hh, used by vctest*.cc only

# Generate files with instanciations, external declarations, and also the
# invocations in the test for each instance.
dune_instance_begin(FILES vcvectortest.hh vcvectortest.cc)
foreach(SCALAR IN LISTS VCTEST_TYPES)
  dune_instance_add(ID "${SCALAR}")
  foreach(POINT IN ITEMS
      Type
      BinaryOpsScalarVector BinaryOpsVectorScalar
      BinaryOpsProxyVector BinaryOpsVectorProxy)
    dune_instance_add(TEMPLATE POINT ID "${POINT}_${SCALAR}"
      FILES vctest_vector.cc vctest_mask.cc)
  endforeach()
endforeach()
dune_instance_end()
dune_list_filter(DUNE_INSTANCE_GENERATED INCLUDE REGEX [[\.cc$]])
dune_add_test(NAME vcvectortest
  SOURCES ${DUNE_INSTANCE_GENERATED}
  LINK_LIBRARIES dunecommon
  CMAKE_GUARD Vc_FOUND
)
add_dune_vc_flags(vcvectortest)
# no need to install vcvectortest.hh, used by vctest*.cc only

=== debian/changelog ===
dune-common (2.7.0-5ubuntu1) groovy; urgency=medium

  * Lower parallel builds on ppc64el and s390x

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 17 Jul 2020 18:50:24 +0200

dune-common (2.7.0-5) unstable; urgency=medium

  * Upload to unstable.

 -- Ansgar <ansgar@debian.org>  Wed, 15 Jul 2020 12:29:39 +0200

dune-common (2.7.0-4) experimental; urgency=medium

  * Only build "quick" tests on mips64el and mipsel as Debian's
    buildd servers are too slow.

 -- Ansgar <ansgar@debian.org>  Wed, 10 Jun 2020 14:20:16 +0200

dune-common (2.7.0-3) experimental; urgency=medium

  * d/control: Add explicit dependency on libatlas-base-dev.
    CMake's `find_package(LAPACK)` adds `libf77blas.so` to the list
    of interface libraries that other DUNE module link against.

 -- Ansgar <ansgar@debian.org>  Mon, 25 May 2020 14:59:18 +0200

dune-common (2.7.0-2) experimental; urgency=medium

  * d/dune-debian.mk: Add `-ffloat-store` to CXXFLAGS on i386.
    See https://gitlab.dune-project.org/core/dune-common/issues/207
  * d/control: (Build-)Depends on liblapack-dev.  LAPACK is needed by
    functions in `fmatrixev.hh` which are used by new quadrature rule
    implementations in dune-geometry.

 -- Ansgar <ansgar@debian.org>  Thu, 21 May 2020 23:06:05 +0200

dune-common (2.7.0-1) experimental; urgency=medium

  * New upstream release.
  * Add runtime dependency on mpi-default-{bin,dev}. DUNE should by
    default be used with MPI support enabled.
  * Use debhelper compat level 13.
  * Drop patch rename-git-whitespace-hook.patch (applied upstream).
  * Bumped Standards-Version to 4.5.0 (no changes).

 -- Ansgar <ansgar@debian.org>  Wed, 20 May 2020 21:06:31 +0200

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DUNE_DEBIAN_ENV := $(CURDIR)/debian/dune-debian.env
DUNE_CTEST := $(CURDIR)/bin/dune-ctest
DUNE_DEBIAN_DUNECONTROL := $(CURDIR)/bin/dunecontrol

ifneq ($(filter mips64el mipsel,$(DEB_HOST_ARCH)),)
  DUNE_TEST_LABELS=quick
else
  DUNE_TEST_LABELS=
endif

include debian/dune-debian.mk

ifneq (,$(filter ppc64el s390x, $(DEB_HOST_ARCH)))
    DEB_BUILD_OPTIONS=parallel=3
endif

%:
	dh $@ --builddirectory=build

override_dh_auto_build-indep:
	dh_auto_build -- doc

override_dh_installdocs-indep:
	dh_installdocs
	dh_sphinxdoc

## dune-common 2.7.1

=== bin/CMakeLists.txt ===
install(PROGRAMS
  dune-ctest
  duneproject
  dunecontrol
  dune-git-whitespace-hook
  DESTINATION ${CMAKE_INSTALL_BINDIR})

=== lib/CMakeLists.txt ===
install(FILES dunemodules.lib
  DESTINATION ${CMAKE_INSTALL_BINDIR}/../lib)

=== cmake/modules/CMakeLists.txt ===
install(FILES
  AddGMPFlags.cmake
  AddMETISFlags.cmake
  AddParMETISFlags.cmake
  AddPTScotchFlags.cmake
  AddQuadMathFlags.cmake
  AddSuiteSparseFlags.cmake
  AddUMFPackFlags.cmake
  AddVcFlags.cmake
  CheckCXXFeatures.cmake
  CMakeBuiltinFunctionsDocumentation.cmake
  DuneCMakeCompat.cmake
  DuneCommonMacros.cmake
  DuneCxaDemangle.cmake
  DuneDoc.cmake
  DuneDoxygen.cmake
  DuneEnableAllPackages.cmake
  DuneExecuteProcess.cmake
  DuneInstance.cmake
  DuneMacros.cmake
  DuneMPI.cmake
  DunePathHelper.cmake
  DunePkgConfig.cmake
  DunePythonCommonMacros.cmake
  DunePythonFindPackage.cmake
  DunePythonInstallPackage.cmake
  DunePythonRequireVersion.cmake
  DunePythonTestCommand.cmake
  DunePythonVirtualenv.cmake
  DuneSphinxCMakeDoc.cmake
  DuneStreams.cmake
  DuneSymlinkOrCopy.cmake
  DuneTestMacros.cmake
  FindGMP.cmake
  FindInkscape.cmake
  FindLatexMk.cmake
  FindMETIS.cmake
  FindMProtect.cmake
  FindParMETIS.cmake
  FindPTScotch.cmake
  FindSphinx.cmake
  FindSuiteSparse.cmake
  FindTBB.cmake
  FindUMFPack.cmake
  Headercheck.cmake
  LanguageSupport.cmake
  latexmkrc.cmake
  OverloadCompilerFlags.cmake
  UseInkscape.cmake
  UseLATEX.cmake
  UseLatexMk.cmake
  DESTINATION ${DUNE_INSTALL_MODULEDIR})

=== doc/comm/CMakeLists.txt ===
add_executable(poosc08 "poosc08.cc")
target_link_libraries(poosc08 "dunecommon")

add_executable(poosc08_test "poosc08_test.cc")
target_link_libraries(poosc08_test "dunecommon")

add_executable(indexset "indexset.cc")
target_link_libraries(indexset "dunecommon")

add_dune_mpi_flags("poosc08;poosc08_test;indexset")

dune_add_latex_document(
  SOURCE communication.tex
  FATHER_TARGET doc
  INSTALL ${CMAKE_INSTALL_DOCDIR}/comm)

=== dune/common/CMakeLists.txt ===
add_subdirectory("parallel")
add_subdirectory("simd")
add_subdirectory("std")
add_subdirectory("test")

#build the library dunecommon
if(LAPACK_FOUND)
  set(_additional_libs ${LAPACK_LIBRARIES})
elseif(BLAS_FOUND)
  set(_additional_libs ${BLAS_LIBRARIES})
endif(LAPACK_FOUND)

if(HAVE_MPROTECT)
  set(debugallocator_src "debugallocator.cc")
endif(HAVE_MPROTECT)

dune_add_library("dunecommon"
  debugalign.cc
  ${debugallocator_src}
  exceptions.cc
  fmatrixev.cc
  ios_state.cc
  parametertree.cc
  parametertreeparser.cc
  path.cc
  simd/test.cc
  stdstreams.cc
  stdthread.cc
  ADD_LIBS "${_additional_libs}")

add_dune_tbb_flags(dunecommon)
#install headers
install(FILES
        alignedallocator.hh
        arraylist.hh
        assertandreturn.hh
        bartonnackmanifcheck.hh
        bigunsignedint.hh
        binaryfunctions.hh
        bitsetvector.hh
        boundschecking.hh
        classname.hh
        concept.hh
        conditional.hh
        debugalign.hh
        debugallocator.hh
        debugstream.hh
        deprecated.hh
        densematrix.hh
        densevector.hh
        diagonalmatrix.hh
        documentation.hh
        dotproduct.hh
        dynmatrix.hh
        dynmatrixev.hh
        dynvector.hh
        enumset.hh
        exceptions.hh
        filledarray.hh
        float_cmp.cc
        float_cmp.hh
        fmatrix.hh
        fmatrixev.hh
        ftraits.hh
        function.hh
        fvector.hh
        gcd.hh
        genericiterator.hh
        gmpfield.hh
        hash.hh
        hybridutilities.hh
        indent.hh
        indices.hh
        interfaces.hh
        ios_state.hh
        iteratorfacades.hh
        iteratorrange.hh
        keywords.hh
        lcm.hh
        lru.hh
        mallocallocator.hh
        math.hh
        matvectraits.hh
        overloadset.hh
        parameterizedobject.hh
        parametertree.hh
        parametertreeparser.hh
        path.hh
        poolallocator.hh
        power.hh
        precision.hh
        propertymap.hh
        promotiontraits.hh
        proxymemberaccess.hh
        quadmath.hh
        rangeutilities.hh
        reservedvector.hh
        scalarvectorview.hh
        scalarmatrixview.hh
        shared_ptr.hh
        simd.hh
        singleton.hh
        sllist.hh
        stdstreams.hh
        stdthread.hh
        streamoperators.hh
        stringutility.hh
        to_unique_ptr.hh
        timer.hh
        tupleutility.hh
        tuplevector.hh
        typelist.hh
        typetraits.hh
        typeutilities.hh
        unused.hh
        vc.hh
        version.hh
        visibility.hh
DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/common)

# Install some test headers, because they get used by tests in other modules
# We do this here as test will not be considered for make install
install(FILES test/iteratortest.hh
  test/checkmatrixinterface.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/common/test)

=== dune/common/parallel/CMakeLists.txt ===
add_subdirectory(test)
add_subdirectory(benchmark)

#install headers
install(FILES
        collectivecommunication.hh
        communication.hh
        communicator.hh
        indexset.hh
        indicessyncer.hh
        interface.hh
        localindex.hh
        mpicollectivecommunication.hh
        mpicommunication.hh
        mpiguard.hh
        future.hh
        mpifuture.hh
        mpidata.hh
        mpipack.hh
        mpihelper.hh
        mpitraits.hh
        plocalindex.hh
        remoteindices.hh
        selection.hh
        variablesizecommunicator.hh
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/common/parallel)

=== dune/common/simd/CMakeLists.txt ===
add_subdirectory(test)

if(NOT VC_FOUND)
  exclude_dir_from_headercheck()
endif()

#install headers
install(FILES
  base.hh
  defaults.hh
  interface.hh
  io.hh
  loop.hh
  simd.hh
  standard.hh
  test.hh # may be used from dependent modules
  vc.hh
DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/common/simd)

=== dune/common/std/CMakeLists.txt ===
install(
  FILES
  apply.hh
  make_array.hh
  memory.hh
  optional.hh
  type_traits.hh
  utility.hh
  variant.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/common/std)

=== dune/common/test/CMakeLists.txt ===
include(DuneCMakeCompat)
include(DuneInstance)

dune_add_test(SOURCES arithmetictestsuitetest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES arraylisttest.cc
              LABELS quick)

dune_add_test(SOURCES arraytest.cc
              LABELS quick)

dune_add_test(SOURCES assertandreturntest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)
dune_add_test(NAME assertandreturntest_compiletime_fail
              SOURCES assertandreturntest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "TEST_COMPILETIME_FAIL"
              EXPECT_COMPILE_FAIL
              LABELS quick)
dune_add_test(NAME assertandreturntest_ndebug
              SOURCES assertandreturntest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "TEST_NDEBUG"
              LABELS quick)

dune_add_test(SOURCES autocopytest.cc
              LABELS quick)

dune_add_test(SOURCES bigunsignedinttest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES bitsetvectortest.cc
              LABELS quick)

dune_add_test(SOURCES boundscheckingtest.cc
              COMPILE_DEFINITIONS DUNE_CHECK_BOUNDS=1
              LINK_LIBRARIES dunecommon
              LABELS quick)
dune_add_test(SOURCES boundscheckingmvtest.cc
              COMPILE_DEFINITIONS DUNE_CHECK_BOUNDS=1
              LINK_LIBRARIES dunecommon
              LABELS quick)
dune_add_test(SOURCES boundscheckingoptest.cc
              COMPILE_DEFINITIONS DUNE_CHECK_BOUNDS=1
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES calloncetest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES check_fvector_size.cc
              LABELS quick)

dune_add_test(NAME check_fvector_size_fail1
              SOURCES check_fvector_size_fail.cc
              COMPILE_DEFINITIONS DIM=1
              EXPECT_COMPILE_FAIL
              LABELS quick)

dune_add_test(NAME check_fvector_size_fail2
              SOURCES check_fvector_size_fail.cc
              COMPILE_DEFINITIONS DIM=3
              EXPECT_COMPILE_FAIL
              LABELS quick)

dune_add_test(NAME classnametest-demangled
              SOURCES classnametest.cc
              LINK_LIBRARIES dunecommon
              CMAKE_GUARD HAVE_CXA_DEMANGLE
              LABELS quick)

dune_add_test(NAME classnametest-fallback
              SOURCES classnametest.cc
              LINK_LIBRARIES dunecommon
              COMMAND sh
              CMD_ARGS -c [[
# ignore an exit status of 1, but fail on anything else to segfaults fail the test
./classnametest-fallback
err=$?
[ "$err" -eq 1 ] && err=0
exit "$err"]]
              LABELS quick)

dune_add_test(SOURCES concept.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES constexprifelsetest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES debugaligntest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

# Generate files with instanciations, external declarations, and also the
# invocations in the test for each instance.
dune_instance_begin(FILES debugalignsimdtest.hh debugalignsimdtest.cc)
foreach(SCALAR IN ITEMS double bool)
  dune_instance_add(ID "${SCALAR}")
  foreach(POINT IN ITEMS Type BinaryOpsScalarVector BinaryOpsVectorScalar)
    dune_instance_add(TEMPLATE POINT
                      ID "${POINT}_${SCALAR}"
                      FILES debugalignsimd.cc)
  endforeach()
endforeach()
dune_instance_end()
dune_list_filter(DUNE_INSTANCE_GENERATED INCLUDE REGEX [[\.cc$]])
dune_add_test(NAME debugalignsimdtest
              SOURCES ${DUNE_INSTANCE_GENERATED}
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)
dune_add_test(NAME densematrixassignmenttest_fail0
              SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE0"
              EXPECT_COMPILE_FAIL
              LABELS quick)
dune_add_test(NAME densematrixassignmenttest_fail1
              SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE1"
              EXPECT_COMPILE_FAIL
              LABELS quick)
dune_add_test(NAME densematrixassignmenttest_fail2
              SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE2"
              EXPECT_COMPILE_FAIL
              LABELS quick)
dune_add_test(NAME densematrixassignmenttest_fail3
              SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE3"
              EXPECT_COMPILE_FAIL
              LABELS quick)
dune_add_test(NAME densematrixassignmenttest_fail4
              SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE4"
              EXPECT_COMPILE_FAIL
              LABELS quick)
dune_add_test(NAME densematrixassignmenttest_fail5
              SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE5"
              EXPECT_COMPILE_FAIL
              LABELS quick)
dune_add_test(NAME densematrixassignmenttest_fail6
              SOURCES densematrixassignmenttest.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE6"
              EXPECT_COMPILE_FAIL
              LABELS quick)

dune_add_test(SOURCES densevectorassignmenttest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES diagonalmatrixtest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES dynmatrixtest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES dynvectortest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES densevectortest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES enumsettest.cc
              LABELS quick)

dune_add_test(SOURCES filledarraytest.cc
              LABELS quick)

dune_add_test(SOURCES fmatrixtest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)
add_dune_vc_flags(fmatrixtest)

dune_add_test(SOURCES functiontest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES fvectortest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES fvectorconversion1d.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES genericiterator_compile_fail.cc
              EXPECT_COMPILE_FAIL
              LABELS quick)

dune_add_test(SOURCES gcdlcmtest.cc
              LABELS quick)

dune_add_test(SOURCES hybridutilitiestest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES indicestest.cc
              LABELS quick)

dune_add_test(SOURCES integersequence.cc
              LABELS quick)

dune_add_test(SOURCES iteratorfacadetest2.cc
              LABELS quick)

dune_add_test(SOURCES iteratorfacadetest.cc
              LABELS quick)

dune_add_test(SOURCES lrutest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES mathclassifierstest.cc
              LINK_LIBRARIES dunecommon)

dune_add_test(SOURCES mpicommunicationtest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 1 2 4 8
              TIMEOUT 300
              LABELS quick)

dune_add_test(SOURCES mpiguardtest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 1 2 4 8
              TIMEOUT 300
              LABELS quick)

dune_add_test(SOURCES mpihelpertest.cc
              LINK_LIBRARIES dunecommon
              MPI_RANKS 1 2 4 8
              TIMEOUT 300
              LABELS quick)

dune_add_test(NAME mpihelpertest2
              SOURCES mpihelpertest.cc
              COMPILE_DEFINITIONS MPIHELPER_PREINITIALIZE
              LINK_LIBRARIES dunecommon
              MPI_RANKS 1 2 4 8
              TIMEOUT 300
              LABELS quick)

dune_add_test(SOURCES overloadsettest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(NAME parameterizedobjecttest
              SOURCES parameterizedobjecttest.cc parameterizedobjectfactorysingleton.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES parametertreelocaletest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES parametertreetest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES pathtest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES poolallocatortest.cc
              LABELS quick)

dune_add_test(SOURCES powertest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES quadmathtest.cc
              LINK_LIBRARIES dunecommon
              CMAKE_GUARD HAVE_QUADMATH)

dune_add_test(SOURCES rangeutilitiestest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES reservedvectortest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES shared_ptrtest.cc
              LABELS quick)

dune_add_test(SOURCES singletontest.cc
              LABELS quick)

dune_add_test(SOURCES sllisttest.cc
              LABELS quick)

dune_add_test(SOURCES stdidentity.cc
              LABELS quick)

dune_add_test(SOURCES stdapplytest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES stdtypetraitstest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES streamoperatorstest.cc
              LABELS quick)

dune_add_test(SOURCES streamtest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES stringutilitytest.cc
              LINK_LIBRARIES dunecommon
              LABELS quick)

dune_add_test(SOURCES testdebugallocator.cc
              LINK_LIBRARIES dunecommon
              CMAKE_GUARD HAVE_MPROTECT
              LABELS quick)

dune_add_test(NAME testdebugallocator_fail1
              SOURCES testdebugallocator.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE1;EXPECTED_SIGNAL=SIGSEGV;EXPECTED_ALT_SIGNAL=SIGBUS"
              EXPECT_FAIL
              CMAKE_GUARD HAVE_MPROTECT
              LABELS quick)

dune_add_test(NAME testdebugallocator_fail2
              SOURCES testdebugallocator.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE2;EXPECTED_SIGNAL=SIGABRT"
              EXPECT_FAIL
              CMAKE_GUARD HAVE_MPROTECT
              LABELS quick)

dune_add_test(NAME testdebugallocator_fail3
              SOURCES testdebugallocator.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE3;EXPECTED_SIGNAL=SIGABRT"
              EXPECT_FAIL
              CMAKE_GUARD HAVE_MPROTECT
              LABELS quick)

dune_add_test(NAME testdebugallocator_fail4
              SOURCES testdebugallocator.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE4;DEBUG_ALLOCATOR_KEEP=1;EXPECTED_SIGNAL=SIGSEGV;EXPECTED_ALT_SIGNAL=SIGBUS"
              EXPECT_FAIL
              CMAKE_GUARD HAVE_MPROTECT
              LABELS quick)

dune_add_test(NAME testdebugallocator_fail5
              SOURCES testdebugallocator.cc
              LINK_LIBRARIES dunecommon
              COMPILE_DEFINITIONS "FAILURE5;EXPECTED_SIGNAL=SIGSEGV;EXPECTED_ALT_SIGNAL=SIGBUS"
              EXPECT_FAIL

=== dune/common/parallel/benchmark/CMakeLists.txt ===
add_executable(mpi_collective_benchmark EXCLUDE_FROM_ALL mpi_collective_benchmark.cc)
dune_target_link_libraries(mpi_collective_benchmark "dunecommon")
add_dune_mpi_flags(mpi_collective_benchmark)

configure_file(options.ini options.ini COPYONLY)

=== dune/common/parallel/test/CMakeLists.txt ===
--- 
+++ 
@@ -44,3 +44,10 @@
               TIMEOUT 300
               CMAKE_GUARD MPI_FOUND
               LABELS quick)
+
+dune_add_test(SOURCES mpigatherscattertest.cc
+              LINK_LIBRARIES dunecommon
+              MPI_RANKS 2
+              TIMEOUT 300
+              CMAKE_GUARD MPI_FOUND
+              LABELS quick)

=== dune/common/simd/test/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,6 @@
   char "unsigned char" "signed char"
   short int long "long long"
   "unsigned short" unsigned "unsigned long" "unsigned long long"
-  wchar_t char16_t char32_t
   bool
   float double "long double"
   std::complex<float> std::complex<double> "std::complex<long double>"
@@ -43,7 +42,6 @@
   char "unsigned char" "signed char"
   short int long "long long"
   "unsigned short" unsigned "unsigned long" "unsigned long long"
-  wchar_t char16_t char32_t
   bool
   float double "long double"
   std::complex<float> std::complex<double> "std::complex<long double>")

=== debian/changelog ===
dune-common (2.7.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Ansgar <ansgar@debian.org>  Mon, 11 Jan 2021 22:23:00 +0100

dune-common (2.7.1-1) experimental; urgency=medium

  * New upstream release.

 -- Lisa Julia Nebel <lisa_julia.nebel@tu-dresden.de>  Tue, 05 Jan 2021 17:51:34 +0100

=== debian/control ===
Source: dune-common
Section: libs
Priority: optional
Standards-Version: 4.5.0
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ansgar <ansgar@debian.org>
Vcs-Browser: https://salsa.debian.org/science-team/dune-common
Vcs-Git: https://salsa.debian.org/science-team/dune-common.git
Homepage: https://www.dune-project.org/
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.1), gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
 libatlas-base-dev, liblapack-dev
Build-Depends-Indep: doxygen, ghostscript, graphviz, imagemagick, texlive-latex-extra, texlive-latex-recommended, texlive-pictures, python3-sphinx
Rules-Requires-Root: no

Package: libdune-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
 cmake (>= 3.1), gfortran, mpi-default-bin, mpi-default-dev, pkg-config,
 libatlas-base-dev, liblapack-dev
Breaks: libdune-functions-dev (<< 2.5.0~)
Replaces: libdune-functions-dev (<< 2.5.0~)
Recommends: python3
Suggests: libdune-common-doc (= ${source:Version})
Provides: ${dune:shared-library}
Description: toolbox for solving PDEs -- basic classes (development files)
 DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
 for solving partial differential equations (PDEs) with grid-based methods.
 It supports the easy implementation of methods like Finite Elements (FE),
 Finite Volumes (FV), and also Finite Differences (FD).
 .
 This package contains the development files for the basic classes.

Package: libdune-common-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Built-Using: ${dune:doc:Built-Using}
Description: toolbox for solving PDEs -- basic classes (documentation)
 DUNE, the Distributed and Unified Numerics Environment is a modular toolbox
 for solving partial differential equations (PDEs) with grid-based methods.
 It supports the easy implementation of methods like Finite Elements (FE),
 Finite Volumes (FV), and also Finite Differences (FD).
 .
 This package contains the documentation for the basic classes.

=== debian/rules ===
--- 
+++ 
@@ -14,10 +14,6 @@
 
 include debian/dune-debian.mk
 
-ifneq (,$(filter ppc64el s390x, $(DEB_HOST_ARCH)))
-    DEB_BUILD_OPTIONS=parallel=3
-endif
-
 %:
 	dh $@ --builddirectory=build

=== debian/tests/control ===
Tests: basic
Depends:
 libdune-common-dev,
 build-essential,
 mpi-default-bin, mpi-default-dev,
Restrictions: allow-stderr

## dune-common 2.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(dune-common LANGUAGES C CXX)

# make sure our own modules are found
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

# set the script dir for the macros.
set(DUNE_COMMON_SCRIPT_DIR ${PROJECT_SOURCE_DIR}/cmake/scripts)

#include the dune macros
include(DuneMacros)

# start a dune project with information from dune.module
dune_project()

# add subdirectories to execute CMakeLists.txt there
add_subdirectory(bin)
add_subdirectory(cmake)
add_subdirectory(doc)
add_subdirectory(dune)
add_subdirectory(lib)
add_subdirectory(share)

# if Python bindings are enabled, include necessary sub directories.
if(DUNE_ENABLE_PYTHONBINDINGS)
  add_subdirectory(python)
  dune_python_install_package(PATH "python")
endif()

# finalize the dune project, e.g. generating config.h etc.
finalize_dune_project()

=== bin/CMakeLists.txt ===
install(PROGRAMS
  dune-ctest
  duneproject
  dunecontrol
  dunepackaging.py
  dune-git-whitespace-hook
  rmgenerated.py
  setup-dunepy.py
  DESTINATION ${CMAKE_INSTALL_BINDIR})

=== cmake/CMakeLists.txt ===
add_subdirectory(modules)
add_subdirectory(scripts)

=== dune/CMakeLists.txt ===
add_subdirectory(common)

# if Python bindings are enabled, include necessary sub directories.
if(DUNE_ENABLE_PYTHONBINDINGS)
  add_subdirectory(python)
else()
  exclude_subdir_from_headercheck(python)
endif()

=== python/CMakeLists.txt ===
add_subdirectory(dune)

configure_file(setup.py.in setup.py)
configure_file(pyproject.toml.in pyproject.toml)

=== cmake/modules/CMakeLists.txt ===
add_subdirectory(FindPkgConfig)
add_subdirectory(FindPython3)

install(FILES
  AddBLASLapackFlags.cmake
  AddGMPFlags.cmake
  AddMETISFlags.cmake
  AddMPIFlags.cmake
  AddParMETISFlags.cmake
  AddPTScotchFlags.cmake
  AddQuadMathFlags.cmake
  AddTBBFlags.cmake
  AddThreadsFlags.cmake
  AddSuiteSparseFlags.cmake
  AddVcFlags.cmake
  CheckCXXFeatures.cmake
  CMakeBuiltinFunctionsDocumentation.cmake
  DuneAddPybind11Module.cmake
  DuneCMakeCompat.cmake
  DuneCommonMacros.cmake
  DuneCxaDemangle.cmake
  DuneDoc.cmake
  DuneDoxygen.cmake
  DuneEnableAllPackages.cmake
  DuneExecuteProcess.cmake
  DuneInstance.cmake
  DuneMacros.cmake
  DuneMPI.cmake
  DunePathHelper.cmake
  DunePkgConfig.cmake
  DunePythonCommonMacros.cmake
  DunePythonFindPackage.cmake
  DunePythonInstallPackage.cmake
  DunePythonMacros.cmake
  DunePythonTestCommand.cmake
  DunePythonVirtualenv.cmake
  DuneSphinxDoc.cmake
  DuneSphinxCMakeDoc.cmake
  DuneStreams.cmake
  DuneSymlinkOrCopy.cmake
  DuneTestMacros.cmake
  FindGMP.cmake
  FindInkscape.cmake
  FindLatexMk.cmake
  FindMETIS.cmake
  FindParMETIS.cmake
  FindPTScotch.cmake
  FindQuadMath.cmake
  FindSphinx.cmake
  FindSuiteSparse.cmake
  FindTBB.cmake
  Headercheck.cmake
  latexmkrc.cmake
  OverloadCompilerFlags.cmake
  UseInkscape.cmake
  UseLatexMk.cmake
  DESTINATION ${DUNE_INSTALL_MODULEDIR})

=== cmake/scripts/CMakeLists.txt ===
# Install non-executable scripts
install(FILES
  conf.py.in
  CreateDoxyFile.cmake
  envdetect.py
  FinalizeHeadercheck.cmake
  index.rst.in
  InstallFile.cmake
  main77.cc.in
  module_library.cc.in
  pyversion.py
  RunDoxygen.cmake
  sphinx_cmake_dune.py
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dune/cmake/scripts)

# Install executable programs
install(PROGRAMS
  extract_cmake_data.py
  run-in-dune-env.sh.in
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dune/cmake/scripts
)

=== doc/buildsystem/CMakeLists.txt ===
# Install the buildsystem documentation defined in dune-common
install(FILES dune-common.rst DESTINATION ${CMAKE_INSTALL_DOCDIR})

# Also always build the CMake API documentation in dune-common
dune_cmake_sphinx_doc()

=== doc/comm/CMakeLists.txt ===
add_executable(poosc08 "poosc08.cc")
target_link_libraries(poosc08 PUBLIC "dunecommon")

add_executable(poosc08_test "poosc08_test.cc")
target_link_libraries(poosc08_test PUBLIC "dunecommon")

add_executable(indexset "indexset.cc")
target_link_libraries(indexset PUBLIC "dunecommon")

add_dune_mpi_flags("poosc08;poosc08_test;indexset")

dune_add_latex_document(
  SOURCE communication.tex
  FATHER_TARGET doc
  BUILD_ON_INSTALL
  INSTALL ${CMAKE_INSTALL_DOCDIR}/comm)

=== doc/doxygen/CMakeLists.txt ===
# create Doxyfile.in and Doxyfile
add_doxygen_target()

install(
  FILES
    Doxystyle
    doxygen-macros
  DESTINATION
    ${CMAKE_INSTALL_DATAROOTDIR}/dune-common/doc/doxygen
  )

=== dune/common/CMakeLists.txt ===
--- 
+++ 
@@ -4,19 +4,10 @@
 add_subdirectory("test")
 
 #build the library dunecommon
-if(LAPACK_FOUND)
-  set(_additional_libs ${LAPACK_LIBRARIES})
-elseif(BLAS_FOUND)
-  set(_additional_libs ${BLAS_LIBRARIES})
-endif(LAPACK_FOUND)
-
-if(HAVE_MPROTECT)
-  set(debugallocator_src "debugallocator.cc")
-endif(HAVE_MPROTECT)
 
 dune_add_library("dunecommon"
   debugalign.cc
-  ${debugallocator_src}
+  debugallocator.cc
   exceptions.cc
   fmatrixev.cc
   ios_state.cc
@@ -25,10 +16,11 @@
   path.cc
   simd/test.cc
   stdstreams.cc
-  stdthread.cc
-  ADD_LIBS "${_additional_libs}")
+  stdthread.cc)
 
+add_dune_blas_lapack_flags(dunecommon)
 add_dune_tbb_flags(dunecommon)
+
 #install headers
 install(FILES
         alignedallocator.hh
@@ -107,6 +99,7 @@
         stringutility.hh
         to_unique_ptr.hh
         timer.hh
+        transpose.hh
         tupleutility.hh
         tuplevector.hh
         typelist.hh

=== dune/python/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(test)
add_subdirectory(pybind11)

=== debian/changelog ===
dune-common (2.8.0-3) unstable; urgency=medium

  * d/control: remove Breaks/Replaces entries

 -- Patrick Jaap <patrick.jaap@tu-dresden.de>  Thu, 21 Oct 2021 18:29:30 +0200

dune-common (2.8.0-2) experimental; urgency=medium

  * d/patches: Add patch to not install Python scripts

 -- Patrick Jaap <patrick.jaap@tu-dresden.de>  Fri, 08 Oct 2021 12:02:33 +0200

dune-common (2.8.0-1) experimental; urgency=medium

  * New upstream release.
  * Add patch to disable eigenvalue checks for "long double"
  * d/patches: Add patch to force python3 in bin/rmgenerated.py
  * Set standards to 4.5.1

 -- Patrick Jaap <patrick.jaap@tu-dresden.de>  Wed, 15 Sep 2021 10:50:45 +0200

dune-common (2.8.0~rc1-1) experimental; urgency=medium

  * New upstream release.
  * Adapt soname.patch to code changes.
  * d/rules: Explicitly use cmake buildsystem.
  * d/clean: Explicitly clear __pycache__ directory.

 -- Patrick Jaap  <patrick.jaap@tu-dresden.de>  Fri, 20 Aug 2021 09:05:19 -0400

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: dune-common
 Section: libs
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ansgar <ansgar@debian.org>
 Vcs-Browser: https://salsa.debian.org/science-team/dune-common
 Vcs-Git: https://salsa.debian.org/science-team/dune-common.git
 Homepage: https://www.dune-project.org/
 Build-Depends: debhelper-compat (= 13),
- cmake (>= 3.1), gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
+ cmake (>= 3.13), gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
  libatlas-base-dev, liblapack-dev
 Build-Depends-Indep: doxygen, ghostscript, graphviz, imagemagick, texlive-latex-extra, texlive-latex-recommended, texlive-pictures, python3-sphinx
 Rules-Requires-Root: no
@@ -18,10 +18,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends},
- cmake (>= 3.1), gfortran, mpi-default-bin, mpi-default-dev, pkg-config,
+ cmake (>= 3.13), gfortran, mpi-default-bin, mpi-default-dev, pkg-config,
  libatlas-base-dev, liblapack-dev
-Breaks: libdune-functions-dev (<< 2.5.0~)
-Replaces: libdune-functions-dev (<< 2.5.0~)
 Recommends: python3
 Suggests: libdune-common-doc (= ${source:Version})
 Provides: ${dune:shared-library}
